function out=Type3_FLS(u)

x=u.x;
c=u.c; 
au=u.au; 
al=u.al; 
dr=u.dr; 
dl=u.dl; 
rules=u.rules;
alpha=u.alpha;
wuu=u.wuu;
wll=u.wll;
wlu=u.wlu;
wul=u.wul;
num_rule=size(rules,1);
k=length(alpha);
n=length(x);
%%
% u is n*1 where n is number of inputs
% c is n*n_MF where n_MF is the number of MFs for this input
% the dimension of sigma  is the same as c
% the variable rule represent the rule database.
% rule is n_rule*n, where n_rule is the number of rules
%%
% clear all
% clc
% u=[1 2]';
% c=[-1 0 1;-1 0 1];
% sigma=ones(size(c));
% rule=[1  3; 2  3];
% w=rand(2,1);-2 2
%c=[-2 -1 0 1 2;3 4 0 5 6]

%%

%au=zeros(num_rule,n);al=zeros(num_rule,n);
yuu={};yll={};yul={};ylu={};dwuu=zeros(num_rule,k);dwll=zeros(num_rule,k);dwul=zeros(num_rule,k);dwlu=zeros(num_rule,1);
%% MF
y=0;
for k=1:length(alpha)
    
for ii=1:n
    
    for jj=1:length(c{ii})

      if x(ii)>c{ii}{jj} && x(ii)<=(c{ii}{jj}+dr{ii}{jj})
          yuu{ii}(jj)=(1-abs((x(ii)-c{ii}{jj})./dr{ii}{jj}).^au{ii}{jj});
          yll{ii}(jj)=(1-abs((x(ii)-c{ii}{jj})./dr{ii}{jj}).^(1/au{ii}{jj}));
          yul{ii}(jj)=(1-abs((x(ii)-c{ii}{jj})./dr{ii}{jj}).^al{ii}{jj});
          ylu{ii}(jj)=(1-abs((x(ii)-c{ii}{jj})./dr{ii}{jj}).^(1/al{ii}{jj}));
      elseif x(ii)<c{ii}{jj} && x(ii)>=(c{ii}{jj}-dl{ii}{jj})
          yuu{ii}(jj)=(1-abs((x(ii)-c{ii}{jj})./dl{ii}{jj}).^au{ii}{jj});
          yll{ii}(jj)=(1-abs((x(ii)-c{ii}{jj})./dl{ii}{jj}).^(1/au{ii}{jj}));
          yul{ii}(jj)=(1-abs((x(ii)-c{ii}{jj})./dl{ii}{jj}).^al{ii}{jj});
          ylu{ii}(jj)=(1-abs((x(ii)-c{ii}{jj})./dl{ii}{jj}).^(1/al{ii}{jj}));
      elseif x(ii)==c{ii}{jj} 
          yuu{ii}(jj)=1;
          yll{ii}(jj)=1;
          yul{ii}(jj)=1;
          ylu{ii}(jj)=1;
      else
          yuu{ii}(jj)=0;
          yll{ii}(jj)=0;
          yul{ii}(jj)=0;
          ylu{ii}(jj)=0;
      end
      




    end
end
%% Rule fiering
for ii=1:n
   Zuu(:,ii)=yuu{ii}(rules(:,ii));
   Zll(:,ii)=yll{ii}(rules(:,ii));
   Zul(:,ii)=yul{ii}(rules(:,ii));
   Zlu(:,ii)=ylu{ii}(rules(:,ii));
end

zuu(:,k)=prod(Zuu,2);%min
zll(:,k)=prod(Zll,2);%min
zul(:,k)=prod(Zul,2);%min
zlu(:,k)=prod(Zlu,2);%min
%% Type reduction 
sum_zu=(sum(zuu(:,k)+zll(:,k))+0.001);
sum_zl=(sum(zlu(:,k)+zul(:,k))+0.001);
Pu(k,1)=(zuu(:,k)'*wuu(:,k)+zll(:,k)'*wll(:,k))/sum_zu;
Pl(k,1)=(zul(:,k)'*wul(:,k)+zlu(:,k)'*wlu(:,k))/sum_zl;
dwuu(:,k)=alpha(k)*zuu(:,k)/sum_zu;
dwll(:,k)=alpha(k)*zll(:,k)/sum_zu;
dwul(:,k)=alpha(k)*zul(:,k)/sum_zl;
dwlu(:,k)=alpha(k)*zlu(:,k)/sum_zl;

end%aa


fhat=alpha*(Pu+Pl)/sum(alpha);
dwuu=dwuu/sum(alpha);
dwll=dwll/sum(alpha);
dwul=dwul/sum(alpha);
dwlu=dwlu/sum(alpha);

out.fhat=fhat;
out.dwuu=dwuu;
out.dwll=dwll;
out.dwul=dwul;
out.dwlu=dwlu;


end
