clc
clear all

load ex4_data

%% Normalization
max_tri=1*(max(max(abs(Train_data)))); 
max_tsi=1*(max(max(abs(Test_data))));
max_tr=1*max(abs(Target_train));
max_ts=1*max(abs(Target_test));
Train_data=Train_data./max_tri;
Test_data=Test_data./max_tsi;
Target_test=Target_test/max_ts; 
Target_train=Target_train/max_tr; 
%% Parameters 

num_in=3; %number of inputs

% MF parameters
c={{-1  0  1},{-1 0 1},{-1  0  1}};
au={{3 3 3 },{3 3 3 },{3 3 3 }};
al={{2 2 2 },{2 2 2 },{2 2 2 }};
dr={{1 1 1},{1 1 1},{1 1 1}};
dl={{1 1 1},{1 1 1},{1 1 1}};
rules=[1 1 1;2  2 2; 3 3 3];
alpha=[ 0.5];
% Consewuent parameters
M=size(rules,1);%number of rules
wuu=0.5*ones(M,1); % 1 equal with the number of alpha-cuts; 
wul=0.25*ones(M,1);
wlu=0.1*ones(M,1);
wll=0*ones(M,1);
% Kalman initilization 
Puu=1e-3*eye(M);Plu=Puu;Pll=Puu;Pul=Puu;

u.c=c; 
u.au=au; 
u.al=al;
u.dr=dr; 
u.dl=dl;
u.rules=rules;
u.alpha=alpha;
u.wuu=wuu;
u.wll=wll;
u.wlu=wlu;
u.wul=wul;



for epoch=1:100
    epoch
    %% Train 
    E=0;
    nn=randperm(length(Train_data));
    for ii=nn
        x(:,1)=Train_data(ii,:);
        u.x=x;
       out=Type3_FLS(u);
       
        y=out.fhat;

      
      e=Target_train(ii)-y;


      [u.wuu,Puu]=EKF(e,u.wuu,Puu,out.dwuu);
      [u.wul,Pul]=EKF(e,u.wul,Pul,out.dwul);
      [u.wll,Pll]=EKF(e,u.wll,Pll,out.dwll);
      [u.wlu,Plu]=EKF(e,u.wlu,Plu,out.dwlu);
        
         E=E+e^2;
    end
    sqrt(E/size(Train_data,1))
    
       
    
end


   E=0;


for ii=1:size(Test_data,1)
       x(:,1)=Test_data(ii,:);
        u.x=x;
       out=Type3_FLS(u);
       y(ii,1)=out.fhat;
        e=Target_test(ii)-y(ii);
         
         E=E+e^2;
end

Target_test=max_ts*Target_test;
y=max_ts*y;
sqrt(mse(Target_test-y))
%% plot
plot_result